/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSMediaDeviceInfo.h"

#include "JSDOMBinding.h"
#include "MediaDeviceInfo.h"
#include "URL.h"
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsMediaDeviceInfoDeviceId(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaDeviceInfoGroupId(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaDeviceInfoKind(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaDeviceInfoLabel(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSMediaDeviceInfoPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSMediaDeviceInfoPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMediaDeviceInfoPrototype* ptr = new (NotNull, JSC::allocateCell<JSMediaDeviceInfoPrototype>(vm.heap)) JSMediaDeviceInfoPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMediaDeviceInfoPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSMediaDeviceInfoPrototypeTableValues[] =
{
    { "deviceId", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaDeviceInfoDeviceId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "groupId", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaDeviceInfoGroupId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "kind", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaDeviceInfoKind), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "label", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaDeviceInfoLabel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

const ClassInfo JSMediaDeviceInfoPrototype::s_info = { "MediaDeviceInfoPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMediaDeviceInfoPrototype) };

void JSMediaDeviceInfoPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMediaDeviceInfoPrototypeTableValues, *this);
}

const ClassInfo JSMediaDeviceInfo::s_info = { "MediaDeviceInfo", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMediaDeviceInfo) };

JSMediaDeviceInfo::JSMediaDeviceInfo(Structure* structure, JSDOMGlobalObject* globalObject, Ref<MediaDeviceInfo>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSMediaDeviceInfo::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSMediaDeviceInfoPrototype::create(vm, globalObject, JSMediaDeviceInfoPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSMediaDeviceInfo::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSMediaDeviceInfo>(vm, globalObject);
}

void JSMediaDeviceInfo::destroy(JSC::JSCell* cell)
{
    JSMediaDeviceInfo* thisObject = static_cast<JSMediaDeviceInfo*>(cell);
    thisObject->JSMediaDeviceInfo::~JSMediaDeviceInfo();
}

JSMediaDeviceInfo::~JSMediaDeviceInfo()
{
    releaseImpl();
}

EncodedJSValue jsMediaDeviceInfoDeviceId(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaDeviceInfo* castedThis = jsDynamicCast<JSMediaDeviceInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaDeviceInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaDeviceInfo", "deviceId");
        return throwGetterTypeError(*exec, "MediaDeviceInfo", "deviceId");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.deviceId());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaDeviceInfoGroupId(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaDeviceInfo* castedThis = jsDynamicCast<JSMediaDeviceInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaDeviceInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaDeviceInfo", "groupId");
        return throwGetterTypeError(*exec, "MediaDeviceInfo", "groupId");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.groupId());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaDeviceInfoKind(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaDeviceInfo* castedThis = jsDynamicCast<JSMediaDeviceInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaDeviceInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaDeviceInfo", "kind");
        return throwGetterTypeError(*exec, "MediaDeviceInfo", "kind");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.kind());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaDeviceInfoLabel(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaDeviceInfo* castedThis = jsDynamicCast<JSMediaDeviceInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaDeviceInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaDeviceInfo", "label");
        return throwGetterTypeError(*exec, "MediaDeviceInfo", "label");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.label());
    return JSValue::encode(result);
}


bool JSMediaDeviceInfoOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSMediaDeviceInfoOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsMediaDeviceInfo = jsCast<JSMediaDeviceInfo*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMediaDeviceInfo->impl(), jsMediaDeviceInfo);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7MediaDeviceInfo@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15MediaDeviceInfoE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, MediaDeviceInfo* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSMediaDeviceInfo>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7MediaDeviceInfo@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore15MediaDeviceInfoE[2];
#if COMPILER(CLANG)
    // If this fails MediaDeviceInfo does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(MediaDeviceInfo), MediaDeviceInfo_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // MediaDeviceInfo has subclasses. If MediaDeviceInfo has subclasses that get passed
    // to toJS() we currently require MediaDeviceInfo you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSMediaDeviceInfo>(globalObject, impl);
}

MediaDeviceInfo* JSMediaDeviceInfo::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSMediaDeviceInfo*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(MEDIA_STREAM)
