/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSubtleCrypto_h
#define JSSubtleCrypto_h

#if ENABLE(SUBTLE_CRYPTO)

#include "JSDOMWrapper.h"
#include "SubtleCrypto.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSSubtleCrypto : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSSubtleCrypto* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<SubtleCrypto>&& impl)
    {
        JSSubtleCrypto* ptr = new (NotNull, JSC::allocateCell<JSSubtleCrypto>(globalObject->vm().heap)) JSSubtleCrypto(structure, globalObject, WTF::move(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* getPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static SubtleCrypto* toWrapped(JSC::JSValue);
    static void destroy(JSC::JSCell*);
    ~JSSubtleCrypto();

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }


    // Custom functions
    JSC::JSValue encrypt(JSC::ExecState*);
    JSC::JSValue decrypt(JSC::ExecState*);
    JSC::JSValue sign(JSC::ExecState*);
    JSC::JSValue verify(JSC::ExecState*);
    JSC::JSValue digest(JSC::ExecState*);
    JSC::JSValue generateKey(JSC::ExecState*);
    JSC::JSValue importKey(JSC::ExecState*);
    JSC::JSValue exportKey(JSC::ExecState*);
    JSC::JSValue wrapKey(JSC::ExecState*);
    JSC::JSValue unwrapKey(JSC::ExecState*);
    SubtleCrypto& impl() const { return *m_impl; }
    void releaseImpl() { std::exchange(m_impl, nullptr)->deref(); }

private:
    SubtleCrypto* m_impl;
protected:
    JSSubtleCrypto(JSC::Structure*, JSDOMGlobalObject*, Ref<SubtleCrypto>&&);

    void finishCreation(JSC::VM& vm)
    {
        Base::finishCreation(vm);
        ASSERT(inherits(info()));
    }

};

class JSSubtleCryptoOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, SubtleCrypto*)
{
    static NeverDestroyed<JSSubtleCryptoOwner> owner;
    return &owner.get();
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, SubtleCrypto*);
inline JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, SubtleCrypto& impl) { return toJS(exec, globalObject, &impl); }


} // namespace WebCore

#endif // ENABLE(SUBTLE_CRYPTO)

#endif
