/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSCapabilityRange.h"

#include "CapabilityRange.h"
#include "JSDOMBinding.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsCapabilityRangeMax(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCapabilityRangeMin(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCapabilityRangeSupported(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSCapabilityRangePrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSCapabilityRangePrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCapabilityRangePrototype* ptr = new (NotNull, JSC::allocateCell<JSCapabilityRangePrototype>(vm.heap)) JSCapabilityRangePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCapabilityRangePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSCapabilityRangePrototypeTableValues[] =
{
    { "max", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCapabilityRangeMax), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "min", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCapabilityRangeMin), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "supported", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCapabilityRangeSupported), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

const ClassInfo JSCapabilityRangePrototype::s_info = { "CapabilityRangePrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCapabilityRangePrototype) };

void JSCapabilityRangePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCapabilityRangePrototypeTableValues, *this);
}

const ClassInfo JSCapabilityRange::s_info = { "CapabilityRange", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCapabilityRange) };

JSCapabilityRange::JSCapabilityRange(Structure* structure, JSDOMGlobalObject* globalObject, Ref<CapabilityRange>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSCapabilityRange::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCapabilityRangePrototype::create(vm, globalObject, JSCapabilityRangePrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSCapabilityRange::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSCapabilityRange>(vm, globalObject);
}

void JSCapabilityRange::destroy(JSC::JSCell* cell)
{
    JSCapabilityRange* thisObject = static_cast<JSCapabilityRange*>(cell);
    thisObject->JSCapabilityRange::~JSCapabilityRange();
}

JSCapabilityRange::~JSCapabilityRange()
{
    releaseImpl();
}

EncodedJSValue jsCapabilityRangeMax(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSCapabilityRange* castedThis = jsDynamicCast<JSCapabilityRange*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSCapabilityRangePrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "CapabilityRange", "max");
        return throwGetterTypeError(*exec, "CapabilityRange", "max");
    }
    auto& impl = castedThis->impl();
    JSValue result = (impl.max(exec).hasNoValue() ? jsNull() : impl.max(exec).jsValue());
    return JSValue::encode(result);
}


EncodedJSValue jsCapabilityRangeMin(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSCapabilityRange* castedThis = jsDynamicCast<JSCapabilityRange*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSCapabilityRangePrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "CapabilityRange", "min");
        return throwGetterTypeError(*exec, "CapabilityRange", "min");
    }
    auto& impl = castedThis->impl();
    JSValue result = (impl.min(exec).hasNoValue() ? jsNull() : impl.min(exec).jsValue());
    return JSValue::encode(result);
}


EncodedJSValue jsCapabilityRangeSupported(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSCapabilityRange* castedThis = jsDynamicCast<JSCapabilityRange*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSCapabilityRangePrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "CapabilityRange", "supported");
        return throwGetterTypeError(*exec, "CapabilityRange", "supported");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.supported());
    return JSValue::encode(result);
}


bool JSCapabilityRangeOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSCapabilityRangeOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCapabilityRange = jsCast<JSCapabilityRange*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCapabilityRange->impl(), jsCapabilityRange);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7CapabilityRange@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15CapabilityRangeE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, CapabilityRange* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSCapabilityRange>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7CapabilityRange@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore15CapabilityRangeE[2];
#if COMPILER(CLANG)
    // If this fails CapabilityRange does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(CapabilityRange), CapabilityRange_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // CapabilityRange has subclasses. If CapabilityRange has subclasses that get passed
    // to toJS() we currently require CapabilityRange you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSCapabilityRange>(globalObject, impl);
}

CapabilityRange* JSCapabilityRange::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSCapabilityRange*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(MEDIA_STREAM)
