/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSInternals.h"

#include "CSSStyleDeclaration.h"
#include "ClientRect.h"
#include "ClientRectList.h"
#include "DOMStringList.h"
#include "DOMWindow.h"
#include "Element.h"
#include "ExceptionCode.h"
#include "File.h"
#include "InternalSettings.h"
#include "Internals.h"
#include "JSCSSStyleDeclaration.h"
#include "JSClientRect.h"
#include "JSClientRectList.h"
#include "JSDOMBinding.h"
#include "JSDOMStringList.h"
#include "JSDOMWindow.h"
#include "JSDocument.h"
#include "JSElement.h"
#include "JSFile.h"
#include "JSInternalSettings.h"
#include "JSMallocStatistics.h"
#include "JSMemoryInfo.h"
#include "JSNode.h"
#include "JSNodeList.h"
#include "JSRange.h"
#include "JSScriptProfile.h"
#include "JSTypeConversions.h"
#include "JSXMLHttpRequest.h"
#include "MallocStatistics.h"
#include "MemoryInfo.h"
#include "NameNodeList.h"
#include "Node.h"
#include "NodeList.h"
#include "Range.h"
#include "ScriptProfile.h"
#include "SerializedScriptValue.h"
#include "StyleProperties.h"
#include "TimeRanges.h"
#include "TypeConversions.h"
#include "URL.h"
#include <bindings/ScriptValue.h>
#include <runtime/Error.h>
#include <runtime/JSArray.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

#if ENABLE(CONTENT_FILTERING)
#include "JSMockContentFilterSettings.h"
#include "MockContentFilterSettings.h"
#endif

#if ENABLE(MEDIA_SESSION)
#include "JSMediaSession.h"
#endif

#if ENABLE(MEDIA_SESSION) || ENABLE(VIDEO)
#include "JSHTMLMediaElement.h"
#endif

#if ENABLE(MEDIA_SOURCE)
#include "JSSourceBuffer.h"
#endif

#if ENABLE(VIDEO)
#include "JSTimeRanges.h"
#endif

#if ENABLE(WEB_AUDIO)
#include "JSAudioContext.h"
#endif

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAddress(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNodeNeedsStyleRecalc(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionDescription(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasPausedImageAnimations(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionElementRenderTreeAsText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPreloaded(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsLoadingFromMemoryCache(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionXhrResponseSource(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsSharingStyleSheetContents(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsStyleSheetLoadingSubresources(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionClearMemoryCache(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPruneMemoryCacheToSize(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMemoryCacheSize(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetOverrideCachePolicy(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetOverrideResourceLoadPriority(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetStrictRawResourceValidationPolicyDisabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionClearPageCache(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageCacheSize(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionComputedStyleIncludingVisitedInfo(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEnsureShadowRoot(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEnsureUserAgentShadowRoot(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCreateShadowRoot(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShadowRoot(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShadowRootType(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIncluderFor(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShadowPseudoId(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetShadowPseudoId(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTreeScopeRootNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionParentTreeScope(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLastSpatialNavigationCandidateCount(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfActiveAnimations(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSuspendAnimations(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionResumeAnimations(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAnimationsAreSuspended(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseAnimationAtTimeOnElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseAnimationAtTimeOnPseudoElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseTransitionAtTimeOnElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseTransitionAtTimeOnPseudoElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAttached(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionVisiblePlaceholder(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionFormControlStateOfPreviousHistoryItem(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetFormControlStateOfPreviousHistoryItem(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAbsoluteCaretBounds(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionBoundingBox(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInspectorHighlightRects(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInspectorHighlightObject(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerCountForNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerRangeForNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerDescriptionForNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAddTextMatchMarker(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetMarkedTextMatchesAreHighlighted(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInvalidateFontCache(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetScrollViewPosition(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetViewBaseBackgroundColor(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPagination(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionConfigurationForViewport(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWasLastChangeUserEdit(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionElementShouldAutoComplete(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetEditingValue(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutofilled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetShowAutoFillButton(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCountMatchesForText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPaintControlTints(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionScrollElementToRect(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRangeFromLocationAndLength(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLocationFromRange(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLengthFromRange(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRangeAsText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSubrange(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRangeForDictionaryLookupAtLocation(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetDelegatesScrolling(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLastSpellCheckRequestSequence(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLastSpellCheckProcessedSequence(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUserPreferredLanguages(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUserPreferredLanguages(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUserPreferredAudioCharacteristics(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUserPreferredAudioCharacteristic(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWheelEventHandlerCount(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTouchEventHandlerCount(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNodesFromRect(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionParserMetaData(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUpdateEditorUINowIfScheduled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasSpellingMarker(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasGrammarMarker(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasAutocorrectedMarker(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetContinuousSpellCheckingEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticQuoteSubstitutionEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticLinkDetectionEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticDashSubstitutionEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticTextReplacementEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticSpellingCorrectionEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsOverwriteModeEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionToggleOverwriteModeEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfScrollableAreas(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPageBoxVisible(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLayerTreeAsText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionScrollingStateTreeAsText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMainThreadScrollingReasons(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNonFastScrollableRects(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRepaintRectsAsText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGarbageCollectDocumentResources(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAllowRoundingHacks(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInsertAuthorCSS(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInsertUserCSS(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfLiveNodes(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfLiveDocuments(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionConsoleMessageArgumentCounts(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionOpenDummyInspectorFrontend(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCloseDummyInspectorFrontend(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetJavaScriptProfilingEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetInspectorIsUnderTest(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCounterValue(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageNumber(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShortcutIconURLs(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfPages(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageProperty(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageSizeAndMarginsInPixels(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPageScaleFactor(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPageZoomFactor(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetTextZoomFactor(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUseFixedLayout(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetFixedLayoutSize(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetHeaderHeight(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetFooterHeight(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetTopContentInset(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitWillEnterFullScreenForElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitDidEnterFullScreenForElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitWillExitFullScreenForElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitDidExitFullScreenForElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetApplicationCacheOriginQuota(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRegisterURLSchemeAsBypassingContentSecurityPolicy(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRemoveURLSchemeRegisteredAsBypassingContentSecurityPolicy(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMallocStatistics(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTypeConversions(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMemoryInfo(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGetReferencedFilePaths(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingRepaints(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStopTrackingRepaints(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingLayerFlushes(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLayerFlushCount(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsTimerThrottled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsRequestAnimationFrameThrottled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAreTimersThrottled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingStyleRecalcs(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStyleRecalcCount(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingCompositingUpdates(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCompositingUpdateCount(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUpdateLayoutIgnorePendingStylesheetsAndRunPostLayoutTasks(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGetCurrentCursorInfo(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerTextForListItem(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionToolTipFromElement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionDeserializeBuffer(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSerializeObject(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsFromCurrentWorld(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUsesOverlayScrollbars(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionForceReload(JSC::ExecState*);
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSimulateAudioInterruption(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMediaElementHasCharacteristic(JSC::ExecState*);
#endif
#if ENABLE(ENCRYPTED_MEDIA_V2)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInitializeMockCDM(JSC::ExecState*);
#endif
#if ENABLE(SPEECH_SYNTHESIS)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEnableMockSpeechSynthesizer(JSC::ExecState*);
#endif
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGetImageSourceURL(JSC::ExecState*);
#if ENABLE(VIDEO_TRACK)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCaptionsStyleSheetOverride(JSC::ExecState*);
#endif
#if ENABLE(VIDEO_TRACK)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetCaptionsStyleSheetOverride(JSC::ExecState*);
#endif
#if ENABLE(VIDEO_TRACK)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPrimaryAudioTrackLanguageOverride(JSC::ExecState*);
#endif
#if ENABLE(VIDEO_TRACK)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetCaptionDisplayMode(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCreateTimeRanges(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionClosestTimeToTimeRanges(JSC::ExecState*);
#endif
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsSelectPopupVisible(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPluginUnavailabilityIndicatorObscured(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPluginSnapshotted(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSelectionBounds(JSC::ExecState*);
#if ENABLE(MEDIA_SOURCE)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInitializeMockMediaSource(JSC::ExecState*);
#endif
#if ENABLE(MEDIA_SOURCE)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionBufferedSamplesForTrackID(JSC::ExecState*);
#endif
#if ENABLE(MEDIA_SOURCE)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetShouldGenerateTimestamps(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionBeginMediaSessionInterruption(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEndMediaSessionInterruption(JSC::ExecState*);
#endif
#if ENABLE(MEDIA_SESSION)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSendMediaSessionStartOfInterruptionNotification(JSC::ExecState*);
#endif
#if ENABLE(MEDIA_SESSION)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSendMediaSessionEndOfInterruptionNotification(JSC::ExecState*);
#endif
#if ENABLE(MEDIA_SESSION)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMediaSessionCurrentState(JSC::ExecState*);
#endif
#if ENABLE(MEDIA_SESSION)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMediaElementPlayerVolume(JSC::ExecState*);
#endif
#if ENABLE(MEDIA_SESSION)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSendMediaControlEvent(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionApplicationWillEnterForeground(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionApplicationWillEnterBackground(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetMediaSessionRestrictions(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetMediaElementRestrictions(JSC::ExecState*);
#endif
#if ENABLE(WEB_AUDIO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAudioContextRestrictions(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPostRemoteControlCommand(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSimulateSystemSleep(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSimulateSystemWake(JSC::ExecState*);
#endif
#if ENABLE(VIDEO)
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionElementIsBlockingDisplaySleep(JSC::ExecState*);
#endif
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInstallMockPageOverlay(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageOverlayLayerTreeAsText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPageMuted(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPagePlayingAudio(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCreateFile(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionQueueMicroTask(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTestPreloaderSettingViewport(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPathStringWithShrinkWrappedRects(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsInternalsSettings(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsInternalsWorkerThreadCount(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsInternalsConsoleProfiles(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsInternalsLayoutCount(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
#if ENABLE(CONTENT_FILTERING)
JSC::EncodedJSValue jsInternalsMockContentFilterSettings(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
#endif

class JSInternalsPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSInternalsPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSInternalsPrototype* ptr = new (NotNull, JSC::allocateCell<JSInternalsPrototype>(vm.heap)) JSInternalsPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSInternalsPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSInternalsPrototypeTableValues[] =
{
    { "settings", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsInternalsSettings), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "workerThreadCount", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsInternalsWorkerThreadCount), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "consoleProfiles", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsInternalsConsoleProfiles), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "layoutCount", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsInternalsLayoutCount), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
#if ENABLE(CONTENT_FILTERING)
    { "mockContentFilterSettings", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsInternalsMockContentFilterSettings), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
    { "LAYER_TREE_INCLUDES_VISIBLE_RECTS", DontDelete | ReadOnly | ConstantInteger, NoIntrinsic, (intptr_t)(1), (intptr_t) (0) },
    { "LAYER_TREE_INCLUDES_TILE_CACHES", DontDelete | ReadOnly | ConstantInteger, NoIntrinsic, (intptr_t)(2), (intptr_t) (0) },
    { "LAYER_TREE_INCLUDES_REPAINT_RECTS", DontDelete | ReadOnly | ConstantInteger, NoIntrinsic, (intptr_t)(4), (intptr_t) (0) },
    { "LAYER_TREE_INCLUDES_PAINTING_PHASES", DontDelete | ReadOnly | ConstantInteger, NoIntrinsic, (intptr_t)(8), (intptr_t) (0) },
    { "LAYER_TREE_INCLUDES_CONTENT_LAYERS", DontDelete | ReadOnly | ConstantInteger, NoIntrinsic, (intptr_t)(16), (intptr_t) (0) },
    { "address", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionAddress), (intptr_t) (1) },
    { "nodeNeedsStyleRecalc", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNodeNeedsStyleRecalc), (intptr_t) (1) },
    { "description", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionDescription), (intptr_t) (1) },
    { "hasPausedImageAnimations", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionHasPausedImageAnimations), (intptr_t) (1) },
    { "elementRenderTreeAsText", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionElementRenderTreeAsText), (intptr_t) (1) },
    { "isPreloaded", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsPreloaded), (intptr_t) (1) },
    { "isLoadingFromMemoryCache", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsLoadingFromMemoryCache), (intptr_t) (1) },
    { "xhrResponseSource", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionXhrResponseSource), (intptr_t) (1) },
    { "isSharingStyleSheetContents", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsSharingStyleSheetContents), (intptr_t) (2) },
    { "isStyleSheetLoadingSubresources", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsStyleSheetLoadingSubresources), (intptr_t) (1) },
    { "clearMemoryCache", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionClearMemoryCache), (intptr_t) (0) },
    { "pruneMemoryCacheToSize", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPruneMemoryCacheToSize), (intptr_t) (1) },
    { "memoryCacheSize", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMemoryCacheSize), (intptr_t) (0) },
    { "setOverrideCachePolicy", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetOverrideCachePolicy), (intptr_t) (1) },
    { "setOverrideResourceLoadPriority", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetOverrideResourceLoadPriority), (intptr_t) (1) },
    { "setStrictRawResourceValidationPolicyDisabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetStrictRawResourceValidationPolicyDisabled), (intptr_t) (1) },
    { "clearPageCache", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionClearPageCache), (intptr_t) (0) },
    { "pageCacheSize", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPageCacheSize), (intptr_t) (0) },
    { "computedStyleIncludingVisitedInfo", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionComputedStyleIncludingVisitedInfo), (intptr_t) (1) },
    { "ensureShadowRoot", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionEnsureShadowRoot), (intptr_t) (1) },
    { "ensureUserAgentShadowRoot", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionEnsureUserAgentShadowRoot), (intptr_t) (1) },
    { "createShadowRoot", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCreateShadowRoot), (intptr_t) (1) },
    { "shadowRoot", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionShadowRoot), (intptr_t) (1) },
    { "shadowRootType", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionShadowRootType), (intptr_t) (1) },
    { "includerFor", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIncluderFor), (intptr_t) (1) },
    { "shadowPseudoId", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionShadowPseudoId), (intptr_t) (1) },
    { "setShadowPseudoId", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetShadowPseudoId), (intptr_t) (2) },
    { "treeScopeRootNode", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionTreeScopeRootNode), (intptr_t) (1) },
    { "parentTreeScope", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionParentTreeScope), (intptr_t) (1) },
    { "lastSpatialNavigationCandidateCount", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionLastSpatialNavigationCandidateCount), (intptr_t) (0) },
    { "numberOfActiveAnimations", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNumberOfActiveAnimations), (intptr_t) (0) },
    { "suspendAnimations", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSuspendAnimations), (intptr_t) (0) },
    { "resumeAnimations", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionResumeAnimations), (intptr_t) (0) },
    { "animationsAreSuspended", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionAnimationsAreSuspended), (intptr_t) (0) },
    { "pauseAnimationAtTimeOnElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPauseAnimationAtTimeOnElement), (intptr_t) (3) },
    { "pauseAnimationAtTimeOnPseudoElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPauseAnimationAtTimeOnPseudoElement), (intptr_t) (4) },
    { "pauseTransitionAtTimeOnElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPauseTransitionAtTimeOnElement), (intptr_t) (3) },
    { "pauseTransitionAtTimeOnPseudoElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPauseTransitionAtTimeOnPseudoElement), (intptr_t) (4) },
    { "attached", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionAttached), (intptr_t) (1) },
    { "visiblePlaceholder", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionVisiblePlaceholder), (intptr_t) (1) },
    { "formControlStateOfPreviousHistoryItem", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionFormControlStateOfPreviousHistoryItem), (intptr_t) (0) },
    { "setFormControlStateOfPreviousHistoryItem", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetFormControlStateOfPreviousHistoryItem), (intptr_t) (1) },
    { "absoluteCaretBounds", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionAbsoluteCaretBounds), (intptr_t) (0) },
    { "boundingBox", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionBoundingBox), (intptr_t) (1) },
    { "inspectorHighlightRects", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInspectorHighlightRects), (intptr_t) (0) },
    { "inspectorHighlightObject", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInspectorHighlightObject), (intptr_t) (0) },
    { "markerCountForNode", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMarkerCountForNode), (intptr_t) (2) },
    { "markerRangeForNode", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMarkerRangeForNode), (intptr_t) (3) },
    { "markerDescriptionForNode", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMarkerDescriptionForNode), (intptr_t) (3) },
    { "addTextMatchMarker", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionAddTextMatchMarker), (intptr_t) (2) },
    { "setMarkedTextMatchesAreHighlighted", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetMarkedTextMatchesAreHighlighted), (intptr_t) (1) },
    { "invalidateFontCache", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInvalidateFontCache), (intptr_t) (0) },
    { "setScrollViewPosition", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetScrollViewPosition), (intptr_t) (2) },
    { "setViewBaseBackgroundColor", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetViewBaseBackgroundColor), (intptr_t) (1) },
    { "setPagination", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetPagination), (intptr_t) (2) },
    { "configurationForViewport", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionConfigurationForViewport), (intptr_t) (5) },
    { "wasLastChangeUserEdit", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionWasLastChangeUserEdit), (intptr_t) (1) },
    { "elementShouldAutoComplete", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionElementShouldAutoComplete), (intptr_t) (1) },
    { "setEditingValue", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetEditingValue), (intptr_t) (2) },
    { "setAutofilled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetAutofilled), (intptr_t) (2) },
    { "setShowAutoFillButton", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetShowAutoFillButton), (intptr_t) (2) },
    { "countMatchesForText", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCountMatchesForText), (intptr_t) (3) },
    { "paintControlTints", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPaintControlTints), (intptr_t) (0) },
    { "scrollElementToRect", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionScrollElementToRect), (intptr_t) (5) },
    { "rangeFromLocationAndLength", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionRangeFromLocationAndLength), (intptr_t) (3) },
    { "locationFromRange", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionLocationFromRange), (intptr_t) (2) },
    { "lengthFromRange", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionLengthFromRange), (intptr_t) (2) },
    { "rangeAsText", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionRangeAsText), (intptr_t) (1) },
    { "subrange", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSubrange), (intptr_t) (3) },
    { "rangeForDictionaryLookupAtLocation", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionRangeForDictionaryLookupAtLocation), (intptr_t) (2) },
    { "setDelegatesScrolling", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetDelegatesScrolling), (intptr_t) (1) },
    { "lastSpellCheckRequestSequence", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionLastSpellCheckRequestSequence), (intptr_t) (0) },
    { "lastSpellCheckProcessedSequence", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionLastSpellCheckProcessedSequence), (intptr_t) (0) },
    { "userPreferredLanguages", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionUserPreferredLanguages), (intptr_t) (0) },
    { "setUserPreferredLanguages", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetUserPreferredLanguages), (intptr_t) (1) },
    { "userPreferredAudioCharacteristics", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionUserPreferredAudioCharacteristics), (intptr_t) (0) },
    { "setUserPreferredAudioCharacteristic", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetUserPreferredAudioCharacteristic), (intptr_t) (1) },
    { "wheelEventHandlerCount", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionWheelEventHandlerCount), (intptr_t) (0) },
    { "touchEventHandlerCount", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionTouchEventHandlerCount), (intptr_t) (0) },
    { "nodesFromRect", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNodesFromRect), (intptr_t) (10) },
    { "parserMetaData", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionParserMetaData), (intptr_t) (0) },
    { "updateEditorUINowIfScheduled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionUpdateEditorUINowIfScheduled), (intptr_t) (0) },
    { "hasSpellingMarker", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionHasSpellingMarker), (intptr_t) (2) },
    { "hasGrammarMarker", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionHasGrammarMarker), (intptr_t) (2) },
    { "hasAutocorrectedMarker", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionHasAutocorrectedMarker), (intptr_t) (2) },
    { "setContinuousSpellCheckingEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetContinuousSpellCheckingEnabled), (intptr_t) (1) },
    { "setAutomaticQuoteSubstitutionEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetAutomaticQuoteSubstitutionEnabled), (intptr_t) (1) },
    { "setAutomaticLinkDetectionEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetAutomaticLinkDetectionEnabled), (intptr_t) (1) },
    { "setAutomaticDashSubstitutionEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetAutomaticDashSubstitutionEnabled), (intptr_t) (1) },
    { "setAutomaticTextReplacementEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetAutomaticTextReplacementEnabled), (intptr_t) (1) },
    { "setAutomaticSpellingCorrectionEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetAutomaticSpellingCorrectionEnabled), (intptr_t) (1) },
    { "isOverwriteModeEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsOverwriteModeEnabled), (intptr_t) (0) },
    { "toggleOverwriteModeEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionToggleOverwriteModeEnabled), (intptr_t) (0) },
    { "numberOfScrollableAreas", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNumberOfScrollableAreas), (intptr_t) (0) },
    { "isPageBoxVisible", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsPageBoxVisible), (intptr_t) (1) },
    { "layerTreeAsText", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionLayerTreeAsText), (intptr_t) (1) },
    { "scrollingStateTreeAsText", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionScrollingStateTreeAsText), (intptr_t) (0) },
    { "mainThreadScrollingReasons", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMainThreadScrollingReasons), (intptr_t) (0) },
    { "nonFastScrollableRects", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNonFastScrollableRects), (intptr_t) (0) },
    { "repaintRectsAsText", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionRepaintRectsAsText), (intptr_t) (0) },
    { "garbageCollectDocumentResources", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionGarbageCollectDocumentResources), (intptr_t) (0) },
    { "allowRoundingHacks", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionAllowRoundingHacks), (intptr_t) (0) },
    { "insertAuthorCSS", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInsertAuthorCSS), (intptr_t) (1) },
    { "insertUserCSS", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInsertUserCSS), (intptr_t) (1) },
    { "numberOfLiveNodes", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNumberOfLiveNodes), (intptr_t) (0) },
    { "numberOfLiveDocuments", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNumberOfLiveDocuments), (intptr_t) (0) },
    { "consoleMessageArgumentCounts", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionConsoleMessageArgumentCounts), (intptr_t) (0) },
    { "openDummyInspectorFrontend", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionOpenDummyInspectorFrontend), (intptr_t) (1) },
    { "closeDummyInspectorFrontend", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCloseDummyInspectorFrontend), (intptr_t) (0) },
    { "setJavaScriptProfilingEnabled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetJavaScriptProfilingEnabled), (intptr_t) (1) },
    { "setInspectorIsUnderTest", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetInspectorIsUnderTest), (intptr_t) (1) },
    { "counterValue", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCounterValue), (intptr_t) (1) },
    { "pageNumber", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPageNumber), (intptr_t) (1) },
    { "shortcutIconURLs", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionShortcutIconURLs), (intptr_t) (0) },
    { "numberOfPages", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionNumberOfPages), (intptr_t) (0) },
    { "pageProperty", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPageProperty), (intptr_t) (2) },
    { "pageSizeAndMarginsInPixels", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPageSizeAndMarginsInPixels), (intptr_t) (7) },
    { "setPageScaleFactor", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetPageScaleFactor), (intptr_t) (3) },
    { "setPageZoomFactor", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetPageZoomFactor), (intptr_t) (1) },
    { "setTextZoomFactor", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetTextZoomFactor), (intptr_t) (1) },
    { "setUseFixedLayout", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetUseFixedLayout), (intptr_t) (1) },
    { "setFixedLayoutSize", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetFixedLayoutSize), (intptr_t) (2) },
    { "setHeaderHeight", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetHeaderHeight), (intptr_t) (1) },
    { "setFooterHeight", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetFooterHeight), (intptr_t) (1) },
    { "setTopContentInset", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetTopContentInset), (intptr_t) (1) },
    { "webkitWillEnterFullScreenForElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionWebkitWillEnterFullScreenForElement), (intptr_t) (1) },
    { "webkitDidEnterFullScreenForElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionWebkitDidEnterFullScreenForElement), (intptr_t) (1) },
    { "webkitWillExitFullScreenForElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionWebkitWillExitFullScreenForElement), (intptr_t) (1) },
    { "webkitDidExitFullScreenForElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionWebkitDidExitFullScreenForElement), (intptr_t) (1) },
    { "setApplicationCacheOriginQuota", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetApplicationCacheOriginQuota), (intptr_t) (1) },
    { "registerURLSchemeAsBypassingContentSecurityPolicy", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionRegisterURLSchemeAsBypassingContentSecurityPolicy), (intptr_t) (1) },
    { "removeURLSchemeRegisteredAsBypassingContentSecurityPolicy", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionRemoveURLSchemeRegisteredAsBypassingContentSecurityPolicy), (intptr_t) (1) },
    { "mallocStatistics", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMallocStatistics), (intptr_t) (0) },
    { "typeConversions", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionTypeConversions), (intptr_t) (0) },
    { "memoryInfo", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMemoryInfo), (intptr_t) (0) },
    { "getReferencedFilePaths", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionGetReferencedFilePaths), (intptr_t) (0) },
    { "startTrackingRepaints", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionStartTrackingRepaints), (intptr_t) (0) },
    { "stopTrackingRepaints", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionStopTrackingRepaints), (intptr_t) (0) },
    { "startTrackingLayerFlushes", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionStartTrackingLayerFlushes), (intptr_t) (0) },
    { "layerFlushCount", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionLayerFlushCount), (intptr_t) (0) },
    { "isTimerThrottled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsTimerThrottled), (intptr_t) (1) },
    { "isRequestAnimationFrameThrottled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsRequestAnimationFrameThrottled), (intptr_t) (0) },
    { "areTimersThrottled", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionAreTimersThrottled), (intptr_t) (0) },
    { "startTrackingStyleRecalcs", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionStartTrackingStyleRecalcs), (intptr_t) (0) },
    { "styleRecalcCount", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionStyleRecalcCount), (intptr_t) (0) },
    { "startTrackingCompositingUpdates", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionStartTrackingCompositingUpdates), (intptr_t) (0) },
    { "compositingUpdateCount", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCompositingUpdateCount), (intptr_t) (0) },
    { "updateLayoutIgnorePendingStylesheetsAndRunPostLayoutTasks", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionUpdateLayoutIgnorePendingStylesheetsAndRunPostLayoutTasks), (intptr_t) (0) },
    { "getCurrentCursorInfo", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionGetCurrentCursorInfo), (intptr_t) (0) },
    { "markerTextForListItem", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMarkerTextForListItem), (intptr_t) (1) },
    { "toolTipFromElement", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionToolTipFromElement), (intptr_t) (1) },
    { "deserializeBuffer", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionDeserializeBuffer), (intptr_t) (1) },
    { "serializeObject", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSerializeObject), (intptr_t) (1) },
    { "isFromCurrentWorld", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsFromCurrentWorld), (intptr_t) (1) },
    { "setUsesOverlayScrollbars", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetUsesOverlayScrollbars), (intptr_t) (1) },
    { "forceReload", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionForceReload), (intptr_t) (1) },
#if ENABLE(VIDEO)
    { "simulateAudioInterruption", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSimulateAudioInterruption), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "mediaElementHasCharacteristic", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMediaElementHasCharacteristic), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(ENCRYPTED_MEDIA_V2)
    { "initializeMockCDM", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInitializeMockCDM), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(SPEECH_SYNTHESIS)
    { "enableMockSpeechSynthesizer", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionEnableMockSpeechSynthesizer), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
    { "getImageSourceURL", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionGetImageSourceURL), (intptr_t) (1) },
#if ENABLE(VIDEO_TRACK)
    { "captionsStyleSheetOverride", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCaptionsStyleSheetOverride), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO_TRACK)
    { "setCaptionsStyleSheetOverride", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetCaptionsStyleSheetOverride), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO_TRACK)
    { "setPrimaryAudioTrackLanguageOverride", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetPrimaryAudioTrackLanguageOverride), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO_TRACK)
    { "setCaptionDisplayMode", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetCaptionDisplayMode), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "createTimeRanges", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCreateTimeRanges), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "closestTimeToTimeRanges", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionClosestTimeToTimeRanges), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
    { "isSelectPopupVisible", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsSelectPopupVisible), (intptr_t) (1) },
    { "isPluginUnavailabilityIndicatorObscured", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsPluginUnavailabilityIndicatorObscured), (intptr_t) (1) },
    { "isPluginSnapshotted", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsPluginSnapshotted), (intptr_t) (1) },
    { "selectionBounds", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSelectionBounds), (intptr_t) (0) },
#if ENABLE(MEDIA_SOURCE)
    { "initializeMockMediaSource", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInitializeMockMediaSource), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(MEDIA_SOURCE)
    { "bufferedSamplesForTrackID", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionBufferedSamplesForTrackID), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(MEDIA_SOURCE)
    { "setShouldGenerateTimestamps", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetShouldGenerateTimestamps), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "beginMediaSessionInterruption", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionBeginMediaSessionInterruption), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "endMediaSessionInterruption", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionEndMediaSessionInterruption), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(MEDIA_SESSION)
    { "sendMediaSessionStartOfInterruptionNotification", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSendMediaSessionStartOfInterruptionNotification), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(MEDIA_SESSION)
    { "sendMediaSessionEndOfInterruptionNotification", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSendMediaSessionEndOfInterruptionNotification), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(MEDIA_SESSION)
    { "mediaSessionCurrentState", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMediaSessionCurrentState), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(MEDIA_SESSION)
    { "mediaElementPlayerVolume", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionMediaElementPlayerVolume), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(MEDIA_SESSION)
    { "sendMediaControlEvent", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSendMediaControlEvent), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "applicationWillEnterForeground", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionApplicationWillEnterForeground), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "applicationWillEnterBackground", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionApplicationWillEnterBackground), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "setMediaSessionRestrictions", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetMediaSessionRestrictions), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "setMediaElementRestrictions", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetMediaElementRestrictions), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(WEB_AUDIO)
    { "setAudioContextRestrictions", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetAudioContextRestrictions), (intptr_t) (2) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "postRemoteControlCommand", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPostRemoteControlCommand), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "simulateSystemSleep", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSimulateSystemSleep), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "simulateSystemWake", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSimulateSystemWake), (intptr_t) (0) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
#if ENABLE(VIDEO)
    { "elementIsBlockingDisplaySleep", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionElementIsBlockingDisplaySleep), (intptr_t) (1) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
    { "installMockPageOverlay", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionInstallMockPageOverlay), (intptr_t) (1) },
    { "pageOverlayLayerTreeAsText", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPageOverlayLayerTreeAsText), (intptr_t) (0) },
    { "setPageMuted", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionSetPageMuted), (intptr_t) (1) },
    { "isPagePlayingAudio", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionIsPagePlayingAudio), (intptr_t) (0) },
    { "createFile", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionCreateFile), (intptr_t) (1) },
    { "queueMicroTask", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionQueueMicroTask), (intptr_t) (1) },
    { "testPreloaderSettingViewport", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionTestPreloaderSettingViewport), (intptr_t) (0) },
    { "pathStringWithShrinkWrappedRects", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsInternalsPrototypeFunctionPathStringWithShrinkWrappedRects), (intptr_t) (2) },
};

const ClassInfo JSInternalsPrototype::s_info = { "InternalsPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSInternalsPrototype) };

void JSInternalsPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSInternalsPrototypeTableValues, *this);
}

const ClassInfo JSInternals::s_info = { "Internals", &Base::s_info, 0, CREATE_METHOD_TABLE(JSInternals) };

JSInternals::JSInternals(Structure* structure, JSDOMGlobalObject* globalObject, Ref<Internals>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSInternals::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSInternalsPrototype::create(vm, globalObject, JSInternalsPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSInternals::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSInternals>(vm, globalObject);
}

void JSInternals::destroy(JSC::JSCell* cell)
{
    JSInternals* thisObject = static_cast<JSInternals*>(cell);
    thisObject->JSInternals::~JSInternals();
}

JSInternals::~JSInternals()
{
    releaseImpl();
}

EncodedJSValue jsInternalsSettings(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSInternalsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "Internals", "settings");
        return throwGetterTypeError(*exec, "Internals", "settings");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.settings()));
    return JSValue::encode(result);
}


EncodedJSValue jsInternalsWorkerThreadCount(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSInternalsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "Internals", "workerThreadCount");
        return throwGetterTypeError(*exec, "Internals", "workerThreadCount");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.workerThreadCount());
    return JSValue::encode(result);
}


EncodedJSValue jsInternalsConsoleProfiles(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSInternalsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "Internals", "consoleProfiles");
        return throwGetterTypeError(*exec, "Internals", "consoleProfiles");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.consoleProfiles());
    return JSValue::encode(result);
}


EncodedJSValue jsInternalsLayoutCount(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSInternalsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "Internals", "layoutCount");
        return throwGetterTypeError(*exec, "Internals", "layoutCount");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.layoutCount());
    return JSValue::encode(result);
}


#if ENABLE(CONTENT_FILTERING)
EncodedJSValue jsInternalsMockContentFilterSettings(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSInternalsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "Internals", "mockContentFilterSettings");
        return throwGetterTypeError(*exec, "Internals", "mockContentFilterSettings");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.mockContentFilterSettings()));
    return JSValue::encode(result);
}

#endif

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAddress(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "address");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.address(node));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNodeNeedsStyleRecalc(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "nodeNeedsStyleRecalc");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.nodeNeedsStyleRecalc(node, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionDescription(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "description");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Deprecated::ScriptValue value = { exec->vm(), exec->argument(0) };
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.description(value));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasPausedImageAnimations(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "hasPausedImageAnimations");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.hasPausedImageAnimations(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionElementRenderTreeAsText(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "elementRenderTreeAsText");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.elementRenderTreeAsText(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPreloaded(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isPreloaded");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String url = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isPreloaded(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsLoadingFromMemoryCache(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isLoadingFromMemoryCache");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String url = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isLoadingFromMemoryCache(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionXhrResponseSource(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "xhrResponseSource");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    XMLHttpRequest* xhr = JSXMLHttpRequest::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.xhrResponseSource(xhr));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsSharingStyleSheetContents(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isSharingStyleSheetContents");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* linkA = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    Element* linkB = JSElement::toWrapped(exec->argument(1));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isSharingStyleSheetContents(linkA, linkB));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsStyleSheetLoadingSubresources(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isStyleSheetLoadingSubresources");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* link = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isStyleSheetLoadingSubresources(link));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionClearMemoryCache(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "clearMemoryCache");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.clearMemoryCache();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPruneMemoryCacheToSize(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pruneMemoryCacheToSize");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    int size = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.pruneMemoryCacheToSize(size);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMemoryCacheSize(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "memoryCacheSize");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.memoryCacheSize());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetOverrideCachePolicy(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setOverrideCachePolicy");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    // Keep pointer to the JSString in a local so we don't need to ref the String.
    auto* policyString = exec->argument(0).toString(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    auto& policy = policyString->value(exec);
    if (policy != "UseProtocolCachePolicy" && policy != "ReloadIgnoringCacheData" && policy != "ReturnCacheDataElseLoad" && policy != "ReturnCacheDataDontLoad")
        return throwArgumentMustBeEnumError(*exec, 0, "policy", "Internals", "setOverrideCachePolicy", "\"UseProtocolCachePolicy\", \"ReloadIgnoringCacheData\", \"ReturnCacheDataElseLoad\", \"ReturnCacheDataDontLoad\"");
    impl.setOverrideCachePolicy(policy);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetOverrideResourceLoadPriority(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setOverrideResourceLoadPriority");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    // Keep pointer to the JSString in a local so we don't need to ref the String.
    auto* priorityString = exec->argument(0).toString(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    auto& priority = priorityString->value(exec);
    if (priority != "ResourceLoadPriorityVeryLow" && priority != "ResourceLoadPriorityLow" && priority != "ResourceLoadPriorityMedium" && priority != "ResourceLoadPriorityHigh" && priority != "ResourceLoadPriorityVeryHigh")
        return throwArgumentMustBeEnumError(*exec, 0, "priority", "Internals", "setOverrideResourceLoadPriority", "\"ResourceLoadPriorityVeryLow\", \"ResourceLoadPriorityLow\", \"ResourceLoadPriorityMedium\", \"ResourceLoadPriorityHigh\", \"ResourceLoadPriorityVeryHigh\"");
    impl.setOverrideResourceLoadPriority(priority);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetStrictRawResourceValidationPolicyDisabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setStrictRawResourceValidationPolicyDisabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    bool disabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setStrictRawResourceValidationPolicyDisabled(disabled);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionClearPageCache(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "clearPageCache");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.clearPageCache();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageCacheSize(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pageCacheSize");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.pageCacheSize());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionComputedStyleIncludingVisitedInfo(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "computedStyleIncludingVisitedInfo");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.computedStyleIncludingVisitedInfo(node, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEnsureShadowRoot(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "ensureShadowRoot");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* host = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.ensureShadowRoot(host, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEnsureUserAgentShadowRoot(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "ensureUserAgentShadowRoot");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* host = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.ensureUserAgentShadowRoot(host, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCreateShadowRoot(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "createShadowRoot");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* host = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.createShadowRoot(host, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShadowRoot(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "shadowRoot");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* host = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.shadowRoot(host, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShadowRootType(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "shadowRootType");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* root = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.shadowRootType(root, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIncluderFor(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "includerFor");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.includerFor(node, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShadowPseudoId(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "shadowPseudoId");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.shadowPseudoId(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetShadowPseudoId(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setShadowPseudoId");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String id = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setShadowPseudoId(element, id, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTreeScopeRootNode(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "treeScopeRootNode");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.treeScopeRootNode(node, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionParentTreeScope(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "parentTreeScope");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.parentTreeScope(node, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLastSpatialNavigationCandidateCount(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "lastSpatialNavigationCandidateCount");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.lastSpatialNavigationCandidateCount(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfActiveAnimations(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "numberOfActiveAnimations");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.numberOfActiveAnimations());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSuspendAnimations(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "suspendAnimations");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.suspendAnimations(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionResumeAnimations(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "resumeAnimations");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.resumeAnimations(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAnimationsAreSuspended(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "animationsAreSuspended");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsBoolean(impl.animationsAreSuspended(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseAnimationAtTimeOnElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pauseAnimationAtTimeOnElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String animationName = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    double pauseTime = exec->argument(1).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    Element* element = JSElement::toWrapped(exec->argument(2));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.pauseAnimationAtTimeOnElement(animationName, pauseTime, element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseAnimationAtTimeOnPseudoElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pauseAnimationAtTimeOnPseudoElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 4))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String animationName = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    double pauseTime = exec->argument(1).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    Element* element = JSElement::toWrapped(exec->argument(2));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String pseudoId = exec->argument(3).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.pauseAnimationAtTimeOnPseudoElement(animationName, pauseTime, element, pseudoId, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseTransitionAtTimeOnElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pauseTransitionAtTimeOnElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String propertyName = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    double pauseTime = exec->argument(1).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    Element* element = JSElement::toWrapped(exec->argument(2));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.pauseTransitionAtTimeOnElement(propertyName, pauseTime, element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPauseTransitionAtTimeOnPseudoElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pauseTransitionAtTimeOnPseudoElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 4))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String property = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    double pauseTime = exec->argument(1).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    Element* element = JSElement::toWrapped(exec->argument(2));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String pseudoId = exec->argument(3).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.pauseTransitionAtTimeOnPseudoElement(property, pauseTime, element, pseudoId, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAttached(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "attached");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.attached(node, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionVisiblePlaceholder(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "visiblePlaceholder");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.visiblePlaceholder(element));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionFormControlStateOfPreviousHistoryItem(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "formControlStateOfPreviousHistoryItem");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.formControlStateOfPreviousHistoryItem(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetFormControlStateOfPreviousHistoryItem(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setFormControlStateOfPreviousHistoryItem");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Vector<String> values = toNativeArray<String>(exec, exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setFormControlStateOfPreviousHistoryItem(values, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAbsoluteCaretBounds(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "absoluteCaretBounds");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.absoluteCaretBounds(ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionBoundingBox(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "boundingBox");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.boundingBox(element, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInspectorHighlightRects(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "inspectorHighlightRects");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.inspectorHighlightRects(ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInspectorHighlightObject(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "inspectorHighlightObject");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsStringWithCache(exec, impl.inspectorHighlightObject(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerCountForNode(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "markerCountForNode");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String markerType = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.markerCountForNode(node, markerType, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerRangeForNode(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "markerRangeForNode");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String markerType = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned index = toUInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.markerRangeForNode(node, markerType, index, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerDescriptionForNode(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "markerDescriptionForNode");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String markerType = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned index = toUInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.markerDescriptionForNode(node, markerType, index, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAddTextMatchMarker(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "addTextMatchMarker");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Range* range = JSRange::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    bool isActive = exec->argument(1).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.addTextMatchMarker(range, isActive);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetMarkedTextMatchesAreHighlighted(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setMarkedTextMatchesAreHighlighted");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool flag = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setMarkedTextMatchesAreHighlighted(flag, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInvalidateFontCache(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "invalidateFontCache");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.invalidateFontCache();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetScrollViewPosition(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setScrollViewPosition");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int x = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int y = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setScrollViewPosition(x, y, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetViewBaseBackgroundColor(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setViewBaseBackgroundColor");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String colorValue = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setViewBaseBackgroundColor(colorValue, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPagination(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setPagination");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String mode = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int gap = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());

    size_t argsCount = exec->argumentCount();
    if (argsCount <= 2) {
        impl.setPagination(mode, gap, ec);
        setDOMException(exec, ec);
        return JSValue::encode(jsUndefined());
    }

    int pageLength = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setPagination(mode, gap, pageLength, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionConfigurationForViewport(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "configurationForViewport");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 5))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    float devicePixelRatio = exec->argument(0).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int deviceWidth = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int deviceHeight = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int availableWidth = toInt32(exec, exec->argument(3), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int availableHeight = toInt32(exec, exec->argument(4), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.configurationForViewport(devicePixelRatio, deviceWidth, deviceHeight, availableWidth, availableHeight, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWasLastChangeUserEdit(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "wasLastChangeUserEdit");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* textField = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.wasLastChangeUserEdit(textField, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionElementShouldAutoComplete(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "elementShouldAutoComplete");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* inputElement = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.elementShouldAutoComplete(inputElement, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetEditingValue(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setEditingValue");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* inputElement = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String value = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setEditingValue(inputElement, value, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutofilled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setAutofilled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* inputElement = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    bool enabled = exec->argument(1).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setAutofilled(inputElement, enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetShowAutoFillButton(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setShowAutoFillButton");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* inputElement = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    bool enabled = exec->argument(1).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setShowAutoFillButton(inputElement, enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCountMatchesForText(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "countMatchesForText");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String text = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned findOptions = toUInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String markMatches = exec->argument(2).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.countMatchesForText(text, findOptions, markMatches, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPaintControlTints(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "paintControlTints");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.paintControlTints(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionScrollElementToRect(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "scrollElementToRect");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 5))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int x = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int y = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int w = toInt32(exec, exec->argument(3), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int h = toInt32(exec, exec->argument(4), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.scrollElementToRect(element, x, y, w, h, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRangeFromLocationAndLength(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "rangeFromLocationAndLength");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* scope = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int rangeLocation = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int rangeLength = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.rangeFromLocationAndLength(scope, rangeLocation, rangeLength, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLocationFromRange(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "locationFromRange");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* scope = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    Range* range = JSRange::toWrapped(exec->argument(1));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.locationFromRange(scope, range, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLengthFromRange(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "lengthFromRange");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* scope = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    Range* range = JSRange::toWrapped(exec->argument(1));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.lengthFromRange(scope, range, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRangeAsText(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "rangeAsText");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Range* range = JSRange::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.rangeAsText(range, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSubrange(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "subrange");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Range* range = JSRange::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int rangeLocation = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int rangeLength = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.subrange(range, rangeLocation, rangeLength, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRangeForDictionaryLookupAtLocation(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "rangeForDictionaryLookupAtLocation");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int x = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int y = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.rangeForDictionaryLookupAtLocation(x, y, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetDelegatesScrolling(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setDelegatesScrolling");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setDelegatesScrolling(enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLastSpellCheckRequestSequence(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "lastSpellCheckRequestSequence");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.lastSpellCheckRequestSequence(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLastSpellCheckProcessedSequence(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "lastSpellCheckProcessedSequence");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.lastSpellCheckProcessedSequence(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUserPreferredLanguages(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "userPreferredLanguages");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.userPreferredLanguages());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUserPreferredLanguages(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setUserPreferredLanguages");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Vector<String> languages = toNativeArray<String>(exec, exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setUserPreferredLanguages(languages);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUserPreferredAudioCharacteristics(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "userPreferredAudioCharacteristics");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.userPreferredAudioCharacteristics());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUserPreferredAudioCharacteristic(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setUserPreferredAudioCharacteristic");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String characteristic = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setUserPreferredAudioCharacteristic(characteristic);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWheelEventHandlerCount(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "wheelEventHandlerCount");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.wheelEventHandlerCount(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTouchEventHandlerCount(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "touchEventHandlerCount");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.touchEventHandlerCount(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNodesFromRect(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "nodesFromRect");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 10))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Document* document = JSDocument::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int x = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int y = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned topPadding = toUInt32(exec, exec->argument(3), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned rightPadding = toUInt32(exec, exec->argument(4), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned bottomPadding = toUInt32(exec, exec->argument(5), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned leftPadding = toUInt32(exec, exec->argument(6), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    bool ignoreClipping = exec->argument(7).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    bool allowShadowContent = exec->argument(8).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    bool allowChildFrameContent = exec->argument(9).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.nodesFromRect(document, x, y, topPadding, rightPadding, bottomPadding, leftPadding, ignoreClipping, allowShadowContent, allowChildFrameContent, ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionParserMetaData(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "parserMetaData");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();

    size_t argsCount = exec->argumentCount();
    if (argsCount <= 0) {
        JSValue result = jsStringWithCache(exec, impl.parserMetaData());
        return JSValue::encode(result);
    }

    Deprecated::ScriptValue func = { exec->vm(), exec->argument(0) };
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.parserMetaData(func));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUpdateEditorUINowIfScheduled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "updateEditorUINowIfScheduled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.updateEditorUINowIfScheduled();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasSpellingMarker(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "hasSpellingMarker");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int from = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int length = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.hasSpellingMarker(from, length, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasGrammarMarker(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "hasGrammarMarker");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int from = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int length = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.hasGrammarMarker(from, length, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionHasAutocorrectedMarker(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "hasAutocorrectedMarker");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int from = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int length = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.hasAutocorrectedMarker(from, length, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetContinuousSpellCheckingEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setContinuousSpellCheckingEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setContinuousSpellCheckingEnabled(enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticQuoteSubstitutionEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setAutomaticQuoteSubstitutionEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setAutomaticQuoteSubstitutionEnabled(enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticLinkDetectionEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setAutomaticLinkDetectionEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setAutomaticLinkDetectionEnabled(enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticDashSubstitutionEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setAutomaticDashSubstitutionEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setAutomaticDashSubstitutionEnabled(enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticTextReplacementEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setAutomaticTextReplacementEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setAutomaticTextReplacementEnabled(enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAutomaticSpellingCorrectionEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setAutomaticSpellingCorrectionEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setAutomaticSpellingCorrectionEnabled(enabled, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsOverwriteModeEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isOverwriteModeEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsBoolean(impl.isOverwriteModeEnabled(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionToggleOverwriteModeEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "toggleOverwriteModeEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.toggleOverwriteModeEnabled(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfScrollableAreas(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "numberOfScrollableAreas");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.numberOfScrollableAreas(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPageBoxVisible(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isPageBoxVisible");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int pageNumber = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isPageBoxVisible(pageNumber, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLayerTreeAsText(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "layerTreeAsText");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Document* document = JSDocument::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());

    size_t argsCount = exec->argumentCount();
    if (argsCount <= 1) {
        JSValue result = jsStringWithCache(exec, impl.layerTreeAsText(document, ec));

        setDOMException(exec, ec);
        return JSValue::encode(result);
    }

    uint16_t flags = toUInt16(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.layerTreeAsText(document, flags, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionScrollingStateTreeAsText(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "scrollingStateTreeAsText");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsStringWithCache(exec, impl.scrollingStateTreeAsText(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMainThreadScrollingReasons(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "mainThreadScrollingReasons");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsStringWithCache(exec, impl.mainThreadScrollingReasons(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNonFastScrollableRects(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "nonFastScrollableRects");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.nonFastScrollableRects(ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRepaintRectsAsText(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "repaintRectsAsText");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsStringWithCache(exec, impl.repaintRectsAsText(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGarbageCollectDocumentResources(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "garbageCollectDocumentResources");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.garbageCollectDocumentResources(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAllowRoundingHacks(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "allowRoundingHacks");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.allowRoundingHacks();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInsertAuthorCSS(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "insertAuthorCSS");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String css = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.insertAuthorCSS(css, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInsertUserCSS(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "insertUserCSS");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String css = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.insertUserCSS(css, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfLiveNodes(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "numberOfLiveNodes");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.numberOfLiveNodes());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfLiveDocuments(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "numberOfLiveDocuments");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.numberOfLiveDocuments());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionConsoleMessageArgumentCounts(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "consoleMessageArgumentCounts");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.consoleMessageArgumentCounts());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionOpenDummyInspectorFrontend(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "openDummyInspectorFrontend");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String url = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.openDummyInspectorFrontend(url)));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCloseDummyInspectorFrontend(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "closeDummyInspectorFrontend");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.closeDummyInspectorFrontend();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetJavaScriptProfilingEnabled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setJavaScriptProfilingEnabled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool creates = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setJavaScriptProfilingEnabled(creates, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetInspectorIsUnderTest(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setInspectorIsUnderTest");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool isUnderTest = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setInspectorIsUnderTest(isUnderTest, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCounterValue(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "counterValue");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.counterValue(element));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageNumber(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pageNumber");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());

    size_t argsCount = exec->argumentCount();
    if (argsCount <= 1) {
        JSValue result = jsNumber(impl.pageNumber(element));
        return JSValue::encode(result);
    }

    float pageWidth = exec->argument(1).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    if (argsCount <= 2) {
        JSValue result = jsNumber(impl.pageNumber(element, pageWidth));
        return JSValue::encode(result);
    }

    float pageHeight = exec->argument(2).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.pageNumber(element, pageWidth, pageHeight));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionShortcutIconURLs(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "shortcutIconURLs");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.shortcutIconURLs());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionNumberOfPages(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "numberOfPages");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();

    size_t argsCount = exec->argumentCount();
    if (argsCount <= 0) {
        JSValue result = jsNumber(impl.numberOfPages());
        return JSValue::encode(result);
    }

    double pageWidthInPixels = exec->argument(0).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    if (argsCount <= 1) {
        JSValue result = jsNumber(impl.numberOfPages(pageWidthInPixels));
        return JSValue::encode(result);
    }

    double pageHeightInPixels = exec->argument(1).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.numberOfPages(pageWidthInPixels, pageHeightInPixels));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageProperty(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pageProperty");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String propertyName = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int pageNumber = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.pageProperty(propertyName, pageNumber, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageSizeAndMarginsInPixels(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pageSizeAndMarginsInPixels");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 7))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int pageIndex = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int width = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int height = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int marginTop = toInt32(exec, exec->argument(3), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int marginRight = toInt32(exec, exec->argument(4), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int marginBottom = toInt32(exec, exec->argument(5), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int marginLeft = toInt32(exec, exec->argument(6), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.pageSizeAndMarginsInPixels(pageIndex, width, height, marginTop, marginRight, marginBottom, marginLeft, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPageScaleFactor(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setPageScaleFactor");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 3))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    float scaleFactor = exec->argument(0).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int x = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int y = toInt32(exec, exec->argument(2), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setPageScaleFactor(scaleFactor, x, y, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPageZoomFactor(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setPageZoomFactor");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    float zoomFactor = exec->argument(0).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setPageZoomFactor(zoomFactor, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetTextZoomFactor(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setTextZoomFactor");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    float zoomFactor = exec->argument(0).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setTextZoomFactor(zoomFactor, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUseFixedLayout(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setUseFixedLayout");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    bool useFixedLayout = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setUseFixedLayout(useFixedLayout, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetFixedLayoutSize(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setFixedLayoutSize");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int width = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    int height = toInt32(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setFixedLayoutSize(width, height, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetHeaderHeight(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setHeaderHeight");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    float height = exec->argument(0).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setHeaderHeight(height);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetFooterHeight(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setFooterHeight");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    float height = exec->argument(0).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setFooterHeight(height);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetTopContentInset(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setTopContentInset");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    float contentInset = exec->argument(0).toFloat(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setTopContentInset(contentInset);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitWillEnterFullScreenForElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "webkitWillEnterFullScreenForElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.webkitWillEnterFullScreenForElement(element);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitDidEnterFullScreenForElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "webkitDidEnterFullScreenForElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.webkitDidEnterFullScreenForElement(element);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitWillExitFullScreenForElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "webkitWillExitFullScreenForElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.webkitWillExitFullScreenForElement(element);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionWebkitDidExitFullScreenForElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "webkitDidExitFullScreenForElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.webkitDidExitFullScreenForElement(element);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetApplicationCacheOriginQuota(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setApplicationCacheOriginQuota");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    unsigned long long quota = toUInt64(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setApplicationCacheOriginQuota(quota);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRegisterURLSchemeAsBypassingContentSecurityPolicy(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "registerURLSchemeAsBypassingContentSecurityPolicy");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String scheme = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.registerURLSchemeAsBypassingContentSecurityPolicy(scheme);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionRemoveURLSchemeRegisteredAsBypassingContentSecurityPolicy(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "removeURLSchemeRegisteredAsBypassingContentSecurityPolicy");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String scheme = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.removeURLSchemeRegisteredAsBypassingContentSecurityPolicy(scheme);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMallocStatistics(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "mallocStatistics");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.mallocStatistics()));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTypeConversions(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "typeConversions");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.typeConversions()));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMemoryInfo(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "memoryInfo");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.memoryInfo()));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGetReferencedFilePaths(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "getReferencedFilePaths");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.getReferencedFilePaths());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingRepaints(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "startTrackingRepaints");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.startTrackingRepaints(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStopTrackingRepaints(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "stopTrackingRepaints");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.stopTrackingRepaints(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingLayerFlushes(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "startTrackingLayerFlushes");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.startTrackingLayerFlushes(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionLayerFlushCount(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "layerFlushCount");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.layerFlushCount(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsTimerThrottled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isTimerThrottled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    int timerHandle = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isTimerThrottled(timerHandle, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsRequestAnimationFrameThrottled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isRequestAnimationFrameThrottled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.isRequestAnimationFrameThrottled());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionAreTimersThrottled(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "areTimersThrottled");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.areTimersThrottled());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingStyleRecalcs(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "startTrackingStyleRecalcs");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.startTrackingStyleRecalcs(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStyleRecalcCount(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "styleRecalcCount");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.styleRecalcCount(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionStartTrackingCompositingUpdates(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "startTrackingCompositingUpdates");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    impl.startTrackingCompositingUpdates(ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCompositingUpdateCount(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "compositingUpdateCount");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsNumber(impl.compositingUpdateCount(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionUpdateLayoutIgnorePendingStylesheetsAndRunPostLayoutTasks(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "updateLayoutIgnorePendingStylesheetsAndRunPostLayoutTasks");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;

    size_t argsCount = exec->argumentCount();
    if (argsCount <= 0) {
        impl.updateLayoutIgnorePendingStylesheetsAndRunPostLayoutTasks(ec);
        setDOMException(exec, ec);
        return JSValue::encode(jsUndefined());
    }

    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.updateLayoutIgnorePendingStylesheetsAndRunPostLayoutTasks(node, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGetCurrentCursorInfo(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "getCurrentCursorInfo");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsStringWithCache(exec, impl.getCurrentCursorInfo(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMarkerTextForListItem(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "markerTextForListItem");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.markerTextForListItem(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionToolTipFromElement(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "toolTipFromElement");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.toolTipFromElement(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionDeserializeBuffer(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "deserializeBuffer");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ArrayBuffer* buffer = toArrayBuffer(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = impl.deserializeBuffer(buffer) ? impl.deserializeBuffer(buffer)->deserialize(exec, castedThis->globalObject(), 0) : jsNull();
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSerializeObject(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "serializeObject");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    RefPtr<SerializedScriptValue> obj = SerializedScriptValue::create(exec, exec->argument(0), 0, 0);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.serializeObject(obj)));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsFromCurrentWorld(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isFromCurrentWorld");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Deprecated::ScriptValue obj = { exec->vm(), exec->argument(0) };
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isFromCurrentWorld(obj));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetUsesOverlayScrollbars(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setUsesOverlayScrollbars");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    bool enabled = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setUsesOverlayScrollbars(enabled);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionForceReload(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "forceReload");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    bool endToEnd = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.forceReload(endToEnd);
    return JSValue::encode(jsUndefined());
}

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSimulateAudioInterruption(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "simulateAudioInterruption");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.simulateAudioInterruption(node);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMediaElementHasCharacteristic(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "mediaElementHasCharacteristic");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String characteristic = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.mediaElementHasCharacteristic(node, characteristic, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

#endif

#if ENABLE(ENCRYPTED_MEDIA_V2)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInitializeMockCDM(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "initializeMockCDM");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.initializeMockCDM();
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(SPEECH_SYNTHESIS)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEnableMockSpeechSynthesizer(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "enableMockSpeechSynthesizer");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.enableMockSpeechSynthesizer();
    return JSValue::encode(jsUndefined());
}

#endif

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionGetImageSourceURL(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "getImageSourceURL");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.getImageSourceURL(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

#if ENABLE(VIDEO_TRACK)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCaptionsStyleSheetOverride(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "captionsStyleSheetOverride");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsStringWithCache(exec, impl.captionsStyleSheetOverride(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

#endif

#if ENABLE(VIDEO_TRACK)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetCaptionsStyleSheetOverride(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setCaptionsStyleSheetOverride");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String override = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setCaptionsStyleSheetOverride(override, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO_TRACK)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPrimaryAudioTrackLanguageOverride(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setPrimaryAudioTrackLanguageOverride");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String language = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setPrimaryAudioTrackLanguageOverride(language, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO_TRACK)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetCaptionDisplayMode(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setCaptionDisplayMode");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String mode = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setCaptionDisplayMode(mode, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCreateTimeRanges(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "createTimeRanges");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    RefPtr<Float32Array> startTimes = toFloat32Array(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    RefPtr<Float32Array> endTimes = toFloat32Array(exec->argument(1));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.createTimeRanges(startTimes.get(), endTimes.get())));
    return JSValue::encode(result);
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionClosestTimeToTimeRanges(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "closestTimeToTimeRanges");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    double time = exec->argument(0).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    TimeRanges* ranges = JSTimeRanges::toWrapped(exec->argument(1));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.closestTimeToTimeRanges(time, ranges));
    return JSValue::encode(result);
}

#endif

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsSelectPopupVisible(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isSelectPopupVisible");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Node* node = JSNode::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isSelectPopupVisible(node));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPluginUnavailabilityIndicatorObscured(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isPluginUnavailabilityIndicatorObscured");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isPluginUnavailabilityIndicatorObscured(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPluginSnapshotted(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isPluginSnapshotted");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.isPluginSnapshotted(element, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSelectionBounds(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "selectionBounds");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.selectionBounds(ec)));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

#if ENABLE(MEDIA_SOURCE)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInitializeMockMediaSource(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "initializeMockMediaSource");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.initializeMockMediaSource();
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(MEDIA_SOURCE)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionBufferedSamplesForTrackID(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "bufferedSamplesForTrackID");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    SourceBuffer* buffer = JSSourceBuffer::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String trackID = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.bufferedSamplesForTrackID(buffer, trackID));
    return JSValue::encode(result);
}

#endif

#if ENABLE(MEDIA_SOURCE)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetShouldGenerateTimestamps(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setShouldGenerateTimestamps");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    SourceBuffer* buffer = JSSourceBuffer::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    bool flag = exec->argument(1).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setShouldGenerateTimestamps(buffer, flag);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionBeginMediaSessionInterruption(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "beginMediaSessionInterruption");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.beginMediaSessionInterruption();
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionEndMediaSessionInterruption(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "endMediaSessionInterruption");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String flags = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.endMediaSessionInterruption(flags);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(MEDIA_SESSION)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSendMediaSessionStartOfInterruptionNotification(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "sendMediaSessionStartOfInterruptionNotification");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    // Keep pointer to the JSString in a local so we don't need to ref the String.
    auto* categoryString = exec->argument(0).toString(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    auto& category = categoryString->value(exec);
    if (category != "content" && category != "transient" && category != "transient-solo")
        return throwArgumentMustBeEnumError(*exec, 0, "category", "Internals", "sendMediaSessionStartOfInterruptionNotification", "\"content\", \"transient\", \"transient-solo\"");
    impl.sendMediaSessionStartOfInterruptionNotification(category);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(MEDIA_SESSION)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSendMediaSessionEndOfInterruptionNotification(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "sendMediaSessionEndOfInterruptionNotification");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    // Keep pointer to the JSString in a local so we don't need to ref the String.
    auto* categoryString = exec->argument(0).toString(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    auto& category = categoryString->value(exec);
    if (category != "content" && category != "transient" && category != "transient-solo")
        return throwArgumentMustBeEnumError(*exec, 0, "category", "Internals", "sendMediaSessionEndOfInterruptionNotification", "\"content\", \"transient\", \"transient-solo\"");
    impl.sendMediaSessionEndOfInterruptionNotification(category);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(MEDIA_SESSION)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMediaSessionCurrentState(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "mediaSessionCurrentState");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    MediaSession* session = JSMediaSession::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsStringWithCache(exec, impl.mediaSessionCurrentState(session));
    return JSValue::encode(result);
}

#endif

#if ENABLE(MEDIA_SESSION)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionMediaElementPlayerVolume(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "mediaElementPlayerVolume");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    HTMLMediaElement* element = JSHTMLMediaElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsNumber(impl.mediaElementPlayerVolume(element));
    return JSValue::encode(result);
}

#endif

#if ENABLE(MEDIA_SESSION)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSendMediaControlEvent(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "sendMediaControlEvent");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    // Keep pointer to the JSString in a local so we don't need to ref the String.
    auto* eventString = exec->argument(0).toString(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    auto& event = eventString->value(exec);
    if (event != "play-pause" && event != "next-track" && event != "previous-track")
        return throwArgumentMustBeEnumError(*exec, 0, "event", "Internals", "sendMediaControlEvent", "\"play-pause\", \"next-track\", \"previous-track\"");
    impl.sendMediaControlEvent(event);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionApplicationWillEnterForeground(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "applicationWillEnterForeground");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.applicationWillEnterForeground();
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionApplicationWillEnterBackground(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "applicationWillEnterBackground");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.applicationWillEnterBackground();
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetMediaSessionRestrictions(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setMediaSessionRestrictions");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String mediaType = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String restrictions = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setMediaSessionRestrictions(mediaType, restrictions, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetMediaElementRestrictions(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setMediaElementRestrictions");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    HTMLMediaElement* element = JSHTMLMediaElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String restrictions = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setMediaElementRestrictions(element, restrictions, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(WEB_AUDIO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetAudioContextRestrictions(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setAudioContextRestrictions");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    AudioContext* context = JSAudioContext::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    String restrictions = exec->argument(1).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setAudioContextRestrictions(context, restrictions, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPostRemoteControlCommand(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "postRemoteControlCommand");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    String command = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.postRemoteControlCommand(command, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSimulateSystemSleep(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "simulateSystemSleep");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.simulateSystemSleep();
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSimulateSystemWake(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "simulateSystemWake");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    impl.simulateSystemWake();
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIDEO)
EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionElementIsBlockingDisplaySleep(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "elementIsBlockingDisplaySleep");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    Element* element = JSElement::toWrapped(exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = jsBoolean(impl.elementIsBlockingDisplaySleep(element));
    return JSValue::encode(result);
}

#endif

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionInstallMockPageOverlay(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "installMockPageOverlay");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    // Keep pointer to the JSString in a local so we don't need to ref the String.
    auto* typeString = exec->argument(0).toString(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    auto& type = typeString->value(exec);
    if (type != "view" && type != "document")
        return throwArgumentMustBeEnumError(*exec, 0, "type", "Internals", "installMockPageOverlay", "\"view\", \"document\"");
    impl.installMockPageOverlay(type, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPageOverlayLayerTreeAsText(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pageOverlayLayerTreeAsText");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    ExceptionCode ec = 0;
    JSValue result = jsStringWithCache(exec, impl.pageOverlayLayerTreeAsText(ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionSetPageMuted(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "setPageMuted");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    bool muted = exec->argument(0).toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.setPageMuted(muted);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionIsPagePlayingAudio(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "isPagePlayingAudio");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.isPagePlayingAudio());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionCreateFile(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "createFile");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String url = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.createFile(url)));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionQueueMicroTask(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "queueMicroTask");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    int testNumber = toInt32(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.queueMicroTask(testNumber);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionTestPreloaderSettingViewport(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "testPreloaderSettingViewport");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.testPreloaderSettingViewport());
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsInternalsPrototypeFunctionPathStringWithShrinkWrappedRects(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSInternals* castedThis = jsDynamicCast<JSInternals*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "Internals", "pathStringWithShrinkWrappedRects");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSInternals::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    Vector<double> rectComponents = toNativeArray<double>(exec, exec->argument(0));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    double radius = exec->argument(1).toNumber(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    if (!std::isfinite(radius)) {
        setDOMException(exec, TypeError);
        return JSValue::encode(jsUndefined());
    }
    JSValue result = jsStringWithCache(exec, impl.pathStringWithShrinkWrappedRects(rectComponents, radius, ec));

    setDOMException(exec, ec);
    return JSValue::encode(result);
}

bool JSInternalsOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSInternalsOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsInternals = jsCast<JSInternals*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsInternals->impl(), jsInternals);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7Internals@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore9InternalsE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, Internals* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSInternals>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7Internals@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore9InternalsE[2];
#if COMPILER(CLANG)
    // If this fails Internals does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(Internals), Internals_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // Internals has subclasses. If Internals has subclasses that get passed
    // to toJS() we currently require Internals you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSInternals>(globalObject, impl);
}

Internals* JSInternals::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSInternals*>(value))
        return &wrapper->impl();
    return nullptr;
}

}
